unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Memo1: TMemo;
    StatusBar: TStatusBar;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FStrBuf: TStringList;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    Http, SHDocVw_TLB, StrUtils, Info;

//-----------------------------------------------------------------------------
//  2005.08.27  w肵Ŏn܂URLIEJĂꍇɂURL߂
//  http://www.elists.org/pipermail/delphi-talk/1999-October/001582.html
//  uses SHDocVw_TLB << ActiveX̎荞݁uMicrosoft Internet Controlsv
//  uses StrUtils   
function GetUrlFromInternetExplorer(const BeginText: string): string;
var
    IE: ShellWindows;
    OIE: InternetExplorer;
    i: Integer;
    Url, BText: string;

begin
    Result := '';
    BText := BeginText;
    if (BText = '') then BText := 'http:';

    IE := CoShellWindows.Create;
    for i := 0 to IE.Count - 1 do
    begin
        OIE := (IE.Item(i) as InternetExplorer);
        Url := OIE.LocationURL;

        //  擪r
        if (AnsiStartsText(BText, Url)) then
        begin
            Result := Url;
            Exit;
        end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    FStrBuf := nil;
    FStrBuf := TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    FreeAndNil(FStrBuf);
end;

//-----------------------------------------------------------------------------
//  z[y[WJ
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
    SimpleShellExecute('http://itp.ne.jp/lite/');
end;

//-----------------------------------------------------------------------------
//  URLo
procedure TForm1.SpeedButton2Click(Sender: TObject);
var
    Url: string;
begin
    Url := GetUrlFromInternetExplorer('http://itp.ne.jp/');
    if (Url <> '') then
    begin
        Edit1.Text := Url;
    end;
end;

//-----------------------------------------------------------------------------
//  ^Ey[W̌ʂf[^̂ݔo
procedure RetrieveTable(const Text: string; List: TStrings);
const
    TABLE_S = '<TABLE border="0" cellpadding="0" cellspacing="0" width="520"><TR><TD width="276" STYLE="word-break: break-all"><FONT size="-1">';
    TABLE_E = '</TABLE>';
var
    s, t, temp: string;
    p: integer;
begin
    s := Text;
    s := StringReplace(s, #10, '', [rfReplaceAll]);
    s := StringReplace(s, #13, '', [rfReplaceAll]);

    while true do
    begin
        //  Jn^O
        p := AnsiPos(TABLE_S, s);
        if (p = 0) then break;

        //  ܂Ő؂藎Ƃ
        Delete(s, 1, p - 1 + Length(TABLE_S));

        //  I^O
        p := AnsiPos(TABLE_E, s);
        if (p = 0) then break;

        //  ܂ŎoE؂藎Ƃ
        t := Copy(s, 1, p - 1);
        Delete(s, 1, p - 1 + Length(TABLE_E));

        //  svȂ̂𗎂ƂĂ
        temp := '<IMG SRC="/images/icn_n.gif" border="0" ALT=""></A><BR></TD></TR><TR><TD colspan="12"><HR width="100%" SIZE="2"></TD></TR>';
        t := StringReplace(t, temp, '', [rfReplaceAll]);

        temp := '</FONT></TD><TD width="24" height="24"><IMG src="/images/space.gif" width=24 height=24><BR><BR><IMG src="/images/space.gif"'
              + ' width=24 height=24></TD><TD width=1></TD><TD width="24" height="24"><IMG src="/images/space.gif" width=24 height=24><BR><BR>'
              + '<IMG src="/images/space.gif" width=24 height=24></TD><TD width=1></TD><TD width="24" height="24"><IMG src="/images/space.gif" '
              + 'width=24 height=24><BR><BR><IMG src="/images/space.gif" width=24 height=24></TD><TD width=1></TD><TD width="24" height="24">'
              + '<IMG src="/images/space.gif" width=24 height=24><BR><BR><IMG src="/images/space.gif" width=24 height=24></TD><TD width="16">@</TD><TD width="47" valign="middle">';
        t := StringReplace(t, temp, '', [rfReplaceAll]);

        temp := '<IMG src="/images/zip.gif">';
        t := StringReplace(t, temp, '', [rfReplaceAll]);

        temp := ' target=_blank';
        t := StringReplace(t, temp, '', [rfReplaceAll, rfIgnoreCase]);

        temp := '<FONT size="-1">';
        t := StringReplace(t, temp, '', [rfReplaceAll]);

        temp := '</FONT>';
        t := StringReplace(t, temp, '', [rfReplaceAll]);

        temp := '</A>';
        t := StringReplace(t, temp, '', [rfReplaceAll]);

        temp := '<BR><A HREF="/guide/lite/sw9404.html">';
        t := StringReplace(t, temp, '', [rfReplaceAll]);

        //  Xgɒǉ
        List.Add(t);
    end;
end;

//-----------------------------------------------------------------------------
//  ^Ey[W̌ʂ烊N𔲂o
procedure RetrieveLink(const Text: string; List: TStrings);
const
    LINK_S = '<a href="/servlet/';
    LINK_E = '</a>';
var
    s, t: string;
    p: integer;
begin
    s := Text;

    while true do
    begin
        //  Jn^O
        p := AnsiPos(LINK_S, s);
        if (p = 0) then break;

        //  ܂Ő؂藎Ƃ
        Delete(s, 1, p - 1);

        //  I^O
        p := AnsiPos(LINK_E, s);
        if (p = 0) then break;

        //  ܂ŎoE؂藎Ƃ
        t := Copy(s, 1, p - 1);
        Delete(s, 1, p - 1 + Length(LINK_E));

        //  svȃNXLbv
        if (AnsiEndsText('s', t)) then continue;
        if (AnsiEndsText('y[W', t)) then continue;

        //  N݂̂ɂ
        p := AnsiPos('"', t);
        Delete(t, 1, p);

        p := AnsiPos('"', t);
        t := Copy(t, 1, p - 1);

        //  Xgɒǉ
        List.Add('http://itp.ne.jp' + t);
    end;
end;

//-----------------------------------------------------------------------------
//  _E[h
procedure TForm1.SpeedButton3Click(Sender: TObject);
var
    s: TStringStream;
    i, Count: integer;
begin
    //  --------
    StatusBar.SimpleText := '_E[hJn';

    //  󂯎Xg[쐬
    s := TStringStream.Create('');

    //  󂯎
    GetHttpData(Edit1.Text, s);

    //  No
    FStrBuf.Clear();
    RetrieveLink(s.DataString, FStrBuf);

    //  Sy[W
    Count := 1 + FStrBuf.Count; 

    //  --------
    StatusBar.SimpleText := Format('%2dy[W / S%2dy[W Jn', [1, Count]);

    //  1y[Wڃf[^o
    Memo1.Lines.Clear();
    RetrieveTable(s.DataString, Memo1.Lines);

    //  󂯎Xg[j
    FreeAndNil(s);

    //  N
    for i := 0 to FStrBuf.Count - 1 do
    begin
        //  󂯎Xg[쐬
        s := TStringStream.Create('');

        //  --------
        StatusBar.SimpleText := Format('%2dy[W / S%2dy[W Jn', [i + 2, Count]);

        //  󂯎
        GetHttpData(FStrBuf[i], s);

        //  f[^o
        RetrieveTable(s.DataString, Memo1.Lines);

        //  󂯎Xg[j
        FreeAndNil(s);
    end;

    //  --------
    StatusBar.SimpleText := '_E[h';
end;

end.
